//
// Created by trotfunky on 15/05/19.
//

#ifndef SNIPPETS_DRAWINGELEMENT_H
#define SNIPPETS_DRAWINGELEMENT_H

#include <SFML/Graphics.hpp>
#include <pugixml.hpp>
#include <string>

namespace xmlParser
{
    class DrawingElement
    {
    public:

        DrawingElement();
        explicit DrawingElement(const pugi::xml_node&);

        virtual void draw(sf::RenderWindow&) = 0;

        std::string label;

        int getX() const;
        void setX(int newX);

        int getY() const;
        void setY(int newY);

        const sf::Color& getColor() const;
        void setColor(const sf::Color& newColor);
        void setColor(const std::string& stringColor);

    protected:
        int x;
        int y;

        sf::Color color;

        sf::Shape* shape;
    };
}

#endif //SNIPPETS_DRAWINGELEMENT_H
